package com.ktg.iscs.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ktg.common.mapper.BaseMapperX;
import com.ktg.common.query.LambdaQueryWrapperX;
import com.ktg.iscs.domain.IsKey;
import com.ktg.iscs.domain.vo.key.IsKeyVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 钥匙Mapper接口
 *
 * @author cgj
 * @date 2024-11-19
 */
@Mapper
public interface IsKeyMapper extends BaseMapperX<IsKey>
{
    /**
     * 查询钥匙
     *
     * @param keyId 钥匙主键
     * @return 钥匙
     */
    IsKey selectIsKeyByKeyId(Long keyId);

    /**
     * 通过NFC编号查询钥匙
     */
    default IsKey selectIsKeyByNfc(String nfc) {
        return selectOne(new LambdaQueryWrapperX<IsKey>().eq(IsKey::getKeyNfc, nfc));
    }

    /**
     * 查询钥匙列表
     *
     * @param isKey 钥匙
     * @return 钥匙集合
     */
    List<IsKey> selectIsKeyList(IsKey isKey);

    /**
     * 新增钥匙
     *
     * @param isKey 钥匙
     * @return 结果
     */
    int insertIsKey(IsKey isKey);

    /**
     * 修改钥匙
     *
     * @param isKey 钥匙
     * @return 结果
     */
    int updateIsKey(IsKey isKey);

    /**
     * 删除钥匙
     *
     * @param keyId 钥匙主键
     * @return 结果
     */
    int deleteIsKeyByKeyId(Long keyId);

    /**
     * 批量删除钥匙
     *
     * @param keyIds 需要删除的数据主键集合
     * @return 结果
     */
    int deleteIsKeyByKeyIds(Long[] keyIds);

    Page<IsKeyVO> getIsKeyPage(Page<IsKey> page, @Param(value = "isKey") IsKey isKey);
}
